/*                                SOPHAUX.C                                */
#include "Sophos.h"

/* *********************************************************************** */
   void put_forks ()
/* *********************************************************************** */
{ static SemaStat *stat= NULL;
  if (!stat) stat= common();
  /* Situation erfassen (Veraenderungen an Tischnachbarn etc.): */
  filio(stat, READ | BLOCK); 
  /* Gabeln ablegen: */
  stat->phHung[stat->philId] = THINKING;
  filio(stat, WRITE | RELEASE);
  system (CLEAR);
  printf ("[%d] ", stat->philId);
  return;
}

/* *********************************************************************** */
   void deregister ()
/* *********************************************************************** */
{ static SemaStat *stat=NULL;
  if (!stat) stat= common();
  /* Abmeldung - bzw. Diner beendet: */
  stat->closed = DONE; 
  filio(stat, WRITE | RELEASE); 
  return;
}

/* *********************************************************************** */
   int PutIn (const char *text)
/* *********************************************************************** */
{ int j1, l=strlen(text);
/*printf("\311");*/
  for (j1=0;j1<l;j1++)printf("\315");printf("\273\n\r");
  printf (" \272 %s \272 \n", text);
  printf(" \310");for (j1=0;j1<l+2;j1++)printf("\315");printf("\274\n\r");
  return OK;
}

/* *********************************************************************** */
   void think ()
/* *********************************************************************** */
{ PutIn("ICH DENKE NACH!");

#ifdef  MIT_TIMER
  if (waitMax(3) == KO) deregister(); else
#else //MIT_TIMER
  if ((_getch()) == ESC) deregister(); else 
#endif//MIT_TIMER
  system (CLEAR);
  return;
}

/* *********************************************************************** */
   void eat ()
/* *********************************************************************** */
{ PutIn("ICH ESSE!");

#ifdef  MIT_TIMER
  if (waitMax(5) == KO) deregister(); else; 
#else //MIT_TIMER
  if ((_getch()) == ESC) deregister(); else 
#endif//MIT_TIMER
  system (CLEAR);
  return;
}

/* *********************************************************************** */
   void philosopher ()
/* *********************************************************************** */
{ init();
  while (EWIG)
  { think(); 
    take_forks();
    eat(); 
    put_forks(); 
  }
  return;
}

/* *********************************************************************** */
   int waitMax (int dt)
/* *********************************************************************** */
{ clock_t tNow, tEnd;
  int     ch=' ';
  tNow = clock();
  tEnd = tNow + dt * CLOCKS_PER_SEC;
  while (tNow < tEnd)
  {	tNow=clock();
    if (_kbhit()) 
    { ch = _getch(); 
      switch (ch)
      { case  CR: return(OK);
        case 'q': 
        case 'Q': 
        case ESC: return(KO); 
        default:  break;
      }
    } 
  } return(OK);
}		

/* *********************************************************************** */
int main ()
{ printf ("\n\rAris Christidis:");
  printf ("\n\rLoesungsansatz zum Problem der dinierenden Philosophen");
  printf ("\n\r(OHNE Konsistenz-Ueberpruefung von '"FILNAM"'!)");
  printf ("\n\rVersion: ");

#ifdef  MIT_TIMER
  printf (" Mit Timer /");
#else //MIT_TIMER
  printf (" Ohne Timer /");
#endif//MIT_TIMER

#ifdef  MIT_VERHUNGERN
  printf (" Mit Verhungern");
#else //MIT_VERHUNGERN
  printf (" Ohne Verhungern");
#endif//MIT_VERHUNGERN

  printf ("\n\n\r(mit bel. Taste weiter / Beendigung mit <Esc> )");
  _getch(); system (CLEAR); 
  system ("mode 40,10");
  philosopher();
  return (OK);
}
