/*                                SOPHOS.H                                */
#ifndef SOPHOS_H
  #define SOPHOS_H

  #include <conio.h>
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include <time.h>

  #pragma warning(disable : 4996) // (File handling "veraltet")

  #define MIT_VERHUNGERN
  //#define MIT_TIMER

  #define MORE_SOPHOS

  #define CLEAR   "cls"
  #define FILNAM  "Sema.txt"
//  #define FILPATH FILNAM
  #define FILPATH "../dat/"FILNAM

  #define BLOCKCS "; blockCS:   Entsperrg/Sperrung krit. Abschnitt |"
  #define ACTID   "; actId:     zuletzt blockierender Philosoph    |"
  #define PHILNR  "; philNr:    Anzahl dinierender Philosophen     |"
  #define PHHUNG  "; phHung[%d]: Denk-/Hunger-/EssStatus Phil.Idx %d |"
  #define CLOSED  "; closed:    Diner eroeffnen/schliessen/beenden |"

  #define TOOLATE "Diner-Runde geschlossen!\nTafel eroeffnet!\n(weiter mit bel. Taste)\n"
  #define MINTWO  "Philosophen dinieren nie allein!\n"
  #define THATSIT "Diner beendet!\n\n(weiter mit bel. Taste)\n"

  #define EWIG       1 /* Verwendete Konstanten */
  #define CR        13
  #define ESC       27
  #define WIDTH     10 /* K&R S.148 */
  #define LENGTH    80
  #define MAXPHIL    5 /* Anzahl der Philosophen */
  #define KO         0
  #define OK         1
  #define STAY       0
  #define EXIT       1

  /* Werte fuer BlockCS*/
  enum {UNLOCK, LOCKED};

  /* Werte fuer closed u. Semaphor: */
  enum {INIT=-1, OPEN, SHUT, DONE};

  /*Werte fuer purpose/filio: 0,1,2,0*/
  enum {READ, WRITE, BLOCK, RELEASE=0};

  /* Werte fuer phHung: */
  enum {THINKING, HUNGRY, EATING};

  /* Datentyp: */
  typedef struct AllStat   /* (Strukturname) */
  { FILE *sema;	           /* Semaphor-Datei */
    int   blockCS;         /* Blockierstatus krit. Abschnitt */
    int   actId;           /* Index des zuletzt blockierenden Philosophen */
    int   philNr;          /* Anzahl dinierender Philosophen */
    int   phHung[MAXPHIL]; /* Hungerstatus Philosoph [Index] */
    int   closed;          /* Schliessung der Diner-Runde */
    int   philId;          /* Index Philosoph im lfd. Programm */
  } SemaStat;              /* (Typname) */

  /* Prototypen: */
  SemaStat *common ();
  void      deregister ();
  void      eat ();
  int       filerw (SemaStat *stat, int purpose);
  int       filio (SemaStat *stat, int purpose);
  int       freserve (SemaStat *stat);
  void      init ();
  void      philosopher ();
  void      put_forks ();
  int       PutIn (const char *text);
  void      take_forks ();
  void      think ();
  int       waitMax (int dt);

  /* Makro: */
  #ifndef MAX
  #define MAX(x,y) (( (x) > (y) ) ? (x) : (y))
  #endif//MAX

#endif  SOPHOS_H
